/********************************
* GoogleSearchPort service specific code
********************************/

eval(__readInJS('global/SOAPhelper.js'));
var deHREF = sh_readInXSLT('global/href-id.xsl');

var GoogleSearchPort_destinationURI = 'http://api.google.com/search/beta2';



function GoogleSearchPort_doSpellingSuggestion(id, callXslt, key, phrase) {
  var node = __getNodeForId(id);
  sh_printStartOfConnecting(node);
  var error = {
    isError : false,
    where : '',
    detail : null
  }
  var request = null;
  var response = null;
  error.isError = call();
  if (error.isError) {
    sh_errorCase(error);
  }

  function call() {
    var s = new sh_SOAPCall();
    s.destinationURI = GoogleSearchPort_destinationURI;
    s.actionURI = 'urn:GoogleSearchAction';
    s.targetObjectURI = 'urn:GoogleSearch';
    s.methodName = 'doSpellingSuggestion';
    // set parameters (list of arguments; each one can be of type sh_SOAPParameter)
    s.setParameters(      new sh_SOAPParameter('key', 'string', 'http://www.w3.org/2001/XMLSchema', 'primitive', 'iQRjboo2EiL1ujdXlAgLtcxyvDa4nGEV'),
      new sh_SOAPParameter('phrase', 'string', 'http://www.w3.org/2001/XMLSchema', 'primitive', phrase)    );
    // try call
    try {
      s.asyncInvoke(runFinished);
      return false;
    }
    catch (ex) {
      error.where = 'during_asyncInvoke';
      error.detail = ex;
      return true;
    }
  }

  function runFinished(resp, call) {
    sh_printEndOfConnecting(node);
    if (resp == null) return;
    request = call;
    response = resp;
    if (resp.fault != null) {
      error.isError = true;
      error.where = 'SOAPFault';
      error.detail = resp.fault;
    } else {
      feed(resp, call);
    }
    if (error.isError) {
      sh_errorCase(error);
    }
  }

  function feed(resp, call) {
    try {
      var xslProc;
      // import "id" nodes to the "href" nodes
      if (sh_browser == 'IE') {
        xslProc = deHREF.createProcessor();
        xslProc.input = resp._XMLHttpRequest.responseXML;
        xslProc.transform();
      }
      // apply user stylesheet
      if (sh_browser == 'IE') {
        var input = __parseStringInDOMDocument(xslProc.output);
        var userXSLT = __readInXSLT(callXslt);
        var userXslProc = userXSLT.createProcessor();
        // transform output of XSLT-processing from string to XML (once Mozilla works this will change)
        userXslProc.input = input;
        sh_debugFnc(input, 'Response with resolved references');
        userXslProc.transform();
        var output = userXslProc.output;
      }
      node.innerHTML = output;
    }
    catch (ex) {
      error.isError = true;
      error.where = 'during_getting_answer';
      error.detail = ex;
    }
  }


}


